<?php

error_reporting(E_ALL);
//ini_set('');

$workDir = './';
$exceptionFileList = array('menu.html', 'sitemap_footer.html', 'sitemap_header.html');
$exceptionDirList   = array('webalizer');
$outFile = './sitemap.html';
$headerFile = 'sitemap_head.html';
$footerFile = 'sitemap_footer.html';

class CNode {
  var $title = '';
  var $path = '';
  var $subNodes = array();
  var $countSubNodes = '';

  function cmpNode($a, $b)
  {
    if (count($a->subNodes) > 0 && count($b->subNodes) > 0) {
      if ($a->title == $b->title) {
        return 0;
      }
      return ($a->title > $b->title) ? +1 : -1;
    } elseif (count($a->subNodes) == 0 && count($b->subNodes) == 0) {
      if ($a->title == $b->title) {
        return 0;
      }
      return ($a->title > $b->title) ? +1 : -1;
    } else {
    	if (count($a->subNodes) == count($b->subNodes)) {
        return 0;
      }
      return ($a->countSubNodes < $b->countSubNodes) ? +1 : -1;
    }
  }
}


function scan_dir($dir)
{
	global $workDir, $exceptionFileList, $exceptionDirList, $outFile;
	echo "  $workDir$dir\n";
  if(($dh = opendir($workDir.$dir)) !== false) {
    $nodes = array();
    while(false !== ($file = readdir($dh))) {
      if ($file == '.' || $file == '..' || $file == 'index.html' || in_array($file, $exceptionFileList) || $file == basename($outFile)) {
        continue;
      }
      if (substr($file, -5) == '.html' || substr($file, -4) == '.htm') {
        $content = file_get_contents($workDir.$dir.$file);
        $node = new CNode();
        preg_match('/\<title\>.*?<\/title\>/i', $content, $matches);
        if (isset($matches[0])) {
          $node->title = substr(substr(@$matches[0],7), 0, -8);
        } else {
          $node->title = basename($file, '.html');
        }
        $node->path = $dir.$file;
        $node->subNodes = null;
        $node->countSubNodes = 0;
        $nodes[] = $node;
      } elseif(is_dir($workDir.$dir.$file)) {
	if (in_array($file, $exceptionDirList)) {
      	  continue;
      	}
      	if (is_file($workDir.$dir.$file.'/index.html')) {
          $content = file_get_contents($workDir.$dir.$file.'/index.html');
          $node = new CNode();
          preg_match('/\<title\>.*?<\/title\>/i', $content, $matches);
          if (isset($matches[0])) {
            $node->title = substr(substr(@$matches[0],7), 0, -8);
          } else {
            $node->title = 'Index';
          }
          $node->path = $dir.$file.'/index.html';
          $node->subNodes = scan_dir($dir.$file.'/');
          $node->countSubNodes = countSubNodes($node->subNodes);
          $nodes[] = $node;
        }
      }
    }
    closedir($dh);
    return $nodes;
  } else {
    echo "Error: path $workDir not found\n";
    return array();
  }
}

function countSubNodes(&$nodes)
{
	$count = 0;
  foreach ($nodes as $node)	{
    if (count($node->subNodes) == 0) {
      $count++;
    } else {
      $count += (countSubNodes($node->subNodes) + 1);
    }
  }
  usort($nodes, array('CNode', 'cmpNode'));
  return $count;
}

function outNodes($nodes, $level = -1)
{
	static $id = 0;
  foreach($nodes as $node) {
    if (count($node->subNodes) > 0) {
    	echo "sitemap.add($id,$level,'".$node->title." (".$node->countSubNodes.")', '".$node->path."');\n";
    	$id++;
      outNodes($node->subNodes,$id-1);
    } else {
      echo "sitemap.add($id,$level,'".$node->title."', '".$node->path."');\n";
      $id++;
    }
  }
}


echo "<pre>\n";
$content = file_get_contents($workDir.'index.html');
$node = new CNode();
preg_match('/\<title\>.*?<\/title\>/i', $content, $matches);
if (isset($matches[0])) {
  $node->title = substr(substr(@$matches[0],7), 0, -8);
} else {
  $node->title = 'Index';
}
$node->path = 'index.html';
$node->subNodes = scan_dir('');
$node->countSubNodes = countSubNodes($node->subNodes);
$nodes[] = $node;


echo "  $outFile\n";
ob_start();

if (is_file($headerFile) && is_readable($headerFile)) {
  include $headerFile;
}
?>
<link rel="StyleSheet" href="dtree.css" type="text/css" />
<script type="text/javascript" src="dtree.js"></script
<p><a href="javascript: sitemap.openAll();">open all</a> | <a href="javascript: sitemap.closeAll();">close all</a></p>

	<script type="text/javascript">
		<!--

		sitemap = new dTree('sitemap');
<?php
outNodes($nodes);

?>
document.write(sitemap);

		//-->
	</script>
<?php
if (is_file($footerFile) && is_readable($footerFile)) {
  include $footerFile;
}

$str = ob_get_contents();
ob_end_clean();
$fout = fopen($outFile, 'w');
fwrite($fout, $str);
fclose($fout);

echo " $outFile  \n"; //*/
?>